import * as _feathersjs_feathers from '@feathersjs/feathers';
import { HookContext, Params, Id } from '@feathersjs/feathers';
import { Promisable } from 'type-fest';

type Change<T = any> = {
    before: T;
    item: T;
};
type ChangesById<T = any> = {
    [key: string]: Change<T>;
    [key: number]: Change<T>;
};
type ManipulateParams<H extends HookContext = HookContext> = (params: Params, context: H) => (Promisable<Params>);
interface HookChangesByIdOptions<H extends HookContext = HookContext> {
    skipHooks: boolean;
    params?: ManipulateParams<H>;
    deleteParams?: string[];
    name?: string | string[];
    /** @default false */
    fetchBefore?: boolean;
}
interface ChangesByIdParams extends Params {
    changesById: any;
}
declare module "@feathersjs/feathers" {
    interface Params {
        paginate?: any;
        changesById?: any;
    }
}
declare const changesById: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>, T = any>(cb: (changesById: Record<Id, Change<T>>, context: H) => void | Promise<void>, _options?: Partial<HookChangesByIdOptions<H>>) => (context: H) => Promise<H>;
declare const changesByIdBefore: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>>(context: H, _options: HookChangesByIdOptions<H>) => Promise<Record<string, unknown> | unknown[]>;
declare const changesByIdAfter: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>, T = any>(context: H, itemsBefore: any, cb?: (changesById: Record<Id, Change<T>>, context: H) => void | Promise<void>, _options?: HookChangesByIdOptions<H>) => Promise<Record<Id, Change>>;
declare const getOrFindByIdParams: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any> = HookContext<_feathersjs_feathers.Application<any, any>, any>>(context: H, makeParams: ManipulateParams<H>, options?: Pick<HookChangesByIdOptions<H>, "deleteParams">) => Promise<Params>;

interface ViewContext<H extends HookContext = HookContext, T = any> {
    item: Change<T>;
    subscription: Subscription<H, T>;
    subscriptions: Subscription<H, T>[];
    items: Change<T>[];
    context: HookContext;
}
type ActionOptions<H extends HookContext = HookContext, T = any> = {
    subscription: SubscriptionResolved;
    items: Change<T>[];
    context: H;
    view: Record<string, any>;
};
type Action<H extends HookContext = HookContext, T = any> = (change: Change<T>, options: ActionOptions<H, T>) => (Promisable<void>);
type HookTriggerOptions<H extends HookContext = HookContext, T = any> = Subscription<H, T> | Subscription<H, T>[] | ((context: H) => Promisable<Subscription<H, T> | Subscription<H, T>[]>);
type TransformView<H extends HookContext = HookContext, T = any> = undefined | ((view: Record<string, any>, viewContext: ViewContext<H, T>) => Promisable<Record<string, any>>) | Record<string, any>;
type Condition<H extends HookContext> = true | Record<string, any> | ((item: any, context: H) => Promisable<boolean>);
interface Subscription<H extends HookContext = HookContext, T = any> {
    service?: string | string[];
    method?: string | string[];
    conditionsData?: Condition<H>;
    conditionsResult?: Condition<H>;
    conditionsBefore?: Condition<H>;
    conditionsParams?: Condition<H>;
    view?: TransformView;
    params?: ManipulateParams;
    /** @default true */
    isBlocking?: boolean;
    action: Action<H, T>;
    /** @default false */
    fetchBefore?: boolean;
    [key: string]: any;
    [key: number]: any;
}
interface SubscriptionResolved extends Subscription {
    dataResolved: boolean | Record<string, any>;
    resultResolved: boolean | Record<string, any>;
    beforeResolved: boolean | Record<string, any>;
    paramsResolved: Params;
    identifier: string;
}
declare const trigger: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>, T = any>(options: HookTriggerOptions<H, T>) => (context: H) => Promise<H>;

export { Action, ActionOptions, Change, ChangesById, ChangesByIdParams, Condition, HookChangesByIdOptions, HookTriggerOptions, ManipulateParams, Subscription, SubscriptionResolved, TransformView, changesById, changesByIdAfter, changesByIdBefore, getOrFindByIdParams, trigger };
